## obs-noise 1.0.0

=== CMakeLists.txt ===
# --- Detect if the plugin is build out of tree or not ---
if(CMAKE_PROJECT_NAME STREQUAL "obs-studio")
  set(BUILD_OUT_OF_TREE OFF)
  if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
    legacy_check()
  endif()
else()
  set(BUILD_OUT_OF_TREE ON)
  cmake_minimum_required(VERSION 3.18)
endif()

project(obs-noise VERSION 1.0.0)
set(PROJECT_FULL_NAME "Noise")

# Set new UUIDs when you start to create a new plugin.
set(MACOS_PACKAGE_UUID "b386c47a-1f86-4a03-85c5-438e28bf7124")
set(MACOS_INSTALLER_UUID "8c40d869-b0d5-4c48-a5ba-ca84c35b7c06")

add_library(${PROJECT_NAME} MODULE)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h)

target_sources(${PROJECT_NAME} PRIVATE
	src/obs-noise-source.c
	src/obs-noise-plugin.c
	src/obs-noise-source.h
	src/obs-noise.h
	src/obs-utils.c
	src/obs-utils.h
	src/dual-kawase.c
	src/dual-kawase.h
	src/version.h)

if(BUILD_OUT_OF_TREE)
	find_package(libobs REQUIRED)
	include(cmake/ObsPluginHelpers.cmake)
endif()
  
if(OS_WINDOWS)
	get_filename_component(ISS_FILES_DIR "${CMAKE_BINARY_DIR}\\..\\package" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_FILES_DIR}" ISS_FILES_DIR)
	get_filename_component(ISS_PACKAGE_DIR "${CMAKE_PACKAGE_PREFIX}\\.." ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_PACKAGE_DIR}" ISS_PACKAGE_DIR)
	get_filename_component(ISS_SOURCE_DIR "${PROJECT_SOURCE_DIR}" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_SOURCE_DIR}" ISS_SOURCE_DIR)
	configure_file("installer.iss.in"
			"${PROJECT_BINARY_DIR}/installer.iss"
		)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/resource.rc.in ${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
	target_sources(${PROJECT_NAME} PRIVATE 
		${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
elseif(OS_MACOS)
		set(MACOS_BUNDLEID "com.finitesingularity.${PROJECT_NAME}")
		set(MACOSX_PLUGIN_GUI_IDENTIFIER "${MACOS_BUNDLEID}")
		set(MACOSX_PLUGIN_BUNDLE_VERSION "${PROJECT_VERSION}")
		set(MACOSX_PLUGIN_SHORT_VERSION_STRING "1")
		configure_file(cmake/bundle/macos/installer-macos.pkgproj.in ${CMAKE_BINARY_DIR}/installer-macos.generated.pkgproj)
		target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
endif()

target_link_libraries(${PROJECT_NAME}
	OBS::libobs)

if(BUILD_OUT_OF_TREE)
    if(NOT LIB_OUT_DIR)
        set(LIB_OUT_DIR "/lib/obs-plugins")
    endif()
    if(NOT DATA_OUT_DIR)
        set(DATA_OUT_DIR "/share/obs/obs-plugins/${PROJECT_NAME}")
    endif()
    set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
    install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${LIB_OUT_DIR})
    install(DIRECTORY data/locale
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
    setup_plugin_target(${PROJECT_NAME})
else()
    if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
        set_target_properties_obs(${PROJECT_NAME} PROPERTIES FOLDER "plugins/finitesingularity" PREFIX "")
    else()
        set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/finitesingularity")
        setup_plugin_target(${PROJECT_NAME})
    endif()
endif()

=== debian/changelog ===
obs-noise (1.0.0-2) unstable; urgency=medium

  * Source-only upload.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 13 Apr 2025 01:02:03 -0300

obs-noise (1.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1102272)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 06 Apr 2025 23:43:41 -0300

=== debian/control ===
Source: obs-noise
Section: video
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, libobs-dev, pandoc
Standards-Version: 4.7.2
Homepage: https://obsproject.com/forum/resources/noise.1916/
Vcs-Browser: https://salsa.debian.org/debian/obs-noise
Vcs-Git: https://salsa.debian.org/debian/obs-noise.git

Package: obs-noise
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio
Description: plugin for OBS Studio to generate fractal noises
 The Noise Plugin for OBS provides fractal noise sources and displacement
 filters for generating real-time special effects.
 .
 Overview:
   - The plugin provides a source for generating dynamic and user tunable
     fractal noise textures.
   - There are five different base noise types including block noise, linear
     value noise, smoothstep value noise, Open Simplex noise and
     Worley/Voronoi noise.
   - The plugin allows the user to tune dozens of parameters to create
     countless different effects and textures.
   - The noise can either be static or animated.
   - The plugin also provides plenty of presets that can then be tuned to
     dial in exactly the visual effect you are aiming for.
   - Finally, the plugin also includes a noise displacement filter that uses
     dynamically generated noise to displace pixels in the filtered source.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Exclude "obs-" from NAME and set a DEST
export PLUGIN_NAME=$(shell echo ${DEB_SOURCE} | cut -d"-" -f2-)
export PLUGIN_DEST=debian/${DEB_SOURCE}/usr/lib/${DEB_TARGET_MULTIARCH}/obs-plugins

%:
	dh $@

execute_before_dh_auto_configure:
	if [ "$(shell hostname)" = "canopus" ]; then \
	    LINESUS=$(shell cat data/locale/en-US.ini | wc -l); \
	    LINESPT=$(shell cat data/locale/pt-BR.ini | wc -l); \
	    if [ "$$LINESUS" != "$$LINESPT" ]; then \
	        echo "ERROR: Translation to pt_BR is out of date."; \
	        exit 1; \
	    fi; \
	fi

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_OUT_OF_TREE=On \
                             -DLIB_OUT_DIR=lib/${DEB_TARGET_MULTIARCH}/obs-plugins \
                             -DDATA_OUT_DIR=share/obs/obs-plugins/${PLUGIN_NAME} \
                             -DLINUX_PORTABLE=Off

execute_before_dh_install:
	mkdir -p ${PLUGIN_DEST}
	find -name lib${PLUGIN_NAME}.so -exec cp {} ${PLUGIN_DEST}/${PLUGIN_NAME}.so \;

execute_after_dh_installdocs:
	cd debian/${DEB_SOURCE}/usr/share/doc/${DEB_SOURCE}; \
	pandoc README.md -f markdown -t plain -o README

=== debian/tests/control ===
Test-Command: DEB_TARGET_MULTIARCH=$(dpkg-architecture -qDEB_TARGET_MULTIARCH);
              PLUGIN_NAME=$(dpkg-parsechangelog -SSource | cut -d"-" -f2-);
              g++ -o $AUTOPKGTEST_TMP/load_lib debian/tests/load_lib.cc -ldl -Wall;
              $AUTOPKGTEST_TMP/load_lib /usr/lib/${DEB_TARGET_MULTIARCH}/obs-plugins/${PLUGIN_NAME}.so
Depends: @, g++

=== debian/watch ===
version=4
https://github.com/FiniteSingularity/obs-noise/tags .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
